<?php
/**
 * 2026 Paysera
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author Paysera <plugins@paysera.com>
 * @copyright 2026 Paysera
 * @license http://opensource.org/licenses/afl-3.0.php Academic Free License (AFL 3.0)
 * International Registered Trademark & Property of Paysera
 */

declare(strict_types=1);

namespace Paysera\PrestashopPayments\Dto;

if (!defined('_PS_VERSION_')) {
    exit;
}

class Customer
{
    public function __construct(
        private string $email,
        private ?int $id = null,
        private ?string $firstname = null,
        private ?string $lastname = null
    ) {
    }

    public function getEmail(): string
    {
        return $this->email;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstname(): ?string
    {
        return $this->firstname;
    }

    public function getLastname(): ?string
    {
        return $this->lastname;
    }

    public function toArray(): array
    {
        $data = ['email' => $this->email];

        if ($this->id !== null) {
            $data['id'] = $this->id;
        }

        if ($this->firstname !== null) {
            $data['firstname'] = $this->firstname;
        }

        if ($this->lastname !== null) {
            $data['lastname'] = $this->lastname;
        }

        return $data;
    }
}
